function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React from "react";
import { useState, forwardRef, useRef, useMemo } from "react";
import PropTypes from "prop-types";
import { Editor, EditorState, ContentState } from "draft-js";
import createDecorator from "./createDecorator.js";
var HighlightWithinTextareaFunc = forwardRef(function (props, fwdRef) {
  var placeholder = props.placeholder,
      highlight = props.highlight,
      onChange = props.onChange,
      onDraftJSChange = props.onDraftJSChange,
      value = props.value;

  var _React$useState = React.useState(),
      forceUpdate = _React$useState[1];

  var nextStateRef = useRef({});
  var editorState;

  if (typeof value == 'string') {
    var nextValue = nextStateRef.current.nextValue;

    if (nextValue == value) {
      // Likely the result of cursor movement.
      editorState = nextStateRef.current.nextEditorState;
    } else {
      editorState = EditorState.createWithContent(ContentState.createFromText(value));
    }
  } else {
    // They pulled open the hood and did their own editorState fun.
    editorState = value;
  }

  var contentState = editorState.getCurrentContent();
  var decorator = useMemo(function () {
    return createDecorator(contentState, highlight, value);
  }, [contentState, highlight, value]);
  editorState = EditorState.set(editorState, {
    decorator: decorator
  });

  var onDraftChange = function onDraftChange(nextEditorState) {
    var nextValue = nextEditorState.getCurrentContent().getPlainText();
    nextStateRef.current = {
      nextEditorState: nextEditorState,
      nextValue: nextValue
    };

    if (value == nextValue) {
      // This is just cursor movement or selection changes.
      forceUpdate({});
    } else {
      onChange(nextValue);
    }

    if (onDraftJSChange) {
      onDraftJSChange(nextEditorState);
    }
  };

  return /*#__PURE__*/React.createElement(Editor, {
    editorState: editorState,
    onChange: onDraftChange,
    placeholder: placeholder,
    ref: fwdRef
  });
});
/*
 * For some reason, exporting a FunctionComponent
 * doesn't work when importing in codepen.io, so wrap
 * it in a class component.
 */

var HighlightWithinTextarea = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(HighlightWithinTextarea, _React$Component);

  function HighlightWithinTextarea(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.state = {
      date: new Date()
    };
    return _this;
  }

  var _proto = HighlightWithinTextarea.prototype;

  _proto.render = function render() {
    return /*#__PURE__*/React.createElement(HighlightWithinTextareaFunc, this.props);
  };

  return HighlightWithinTextarea;
}(React.Component);

HighlightWithinTextarea.propTypes = process.env.NODE_ENV !== "production" ? {
  onChange: PropTypes.func,
  onDraftJSChange: PropTypes.func,
  value: PropTypes.oneOfType([PropTypes.string.isRequired, EditorState]),
  highlight: PropTypes.oneOfType([PropTypes.string, PropTypes.array, PropTypes.instanceOf(RegExp), PropTypes.object, PropTypes.func]),
  placeholder: PropTypes.string
} : {};
HighlightWithinTextarea.defaultProps = {
  highlight: null,
  placeholder: "Enter some text..."
};
export default HighlightWithinTextarea;